<?php

	//
	//	This file is part of MythWeb,
	//	a php-based interface into MythTV.
	//
	//	(c) 2002 by Thor Sigvaldason and Isaac Richards
	//	MythWeb is distributed under the
	//	GNU GENERAL PUBLIC LICENSE version 2
	//	(see http://www.gnu.org)
	//

	
//
//	This file contains some classes 
//




//
//	A Time class that understands SQL formatted time,
//	human readable time and UNIX timestamps.
//
class TimeValue
{
	var $sqltime;
	var $unixtime;
	var $humantime;
   
 	var $fgColour;
	var $bgColour;
   
   	//
   	//	Set the background and foreground colours
   	//	for how time is displayed (at the top of
   	//	the listings table).
   	//
   
	function setColour($a, $b)
 	{
		$this->fgColour = $a;
		$this->bgColour = $b;
	}

	//
	//	Given colours, print yourself.
	// 
	
	function printYourself()
	{
		print("\t\t\t\t\t<TD BGCOLOR=\"$this->bgColour\">\n");
		print("\t\t\t\t\t\t&nbsp; $this->humantime\n");
		print("\t\t\t\t\t</TD>\n");
	}

	function setVals($datestr)
	{
		$year = substr($datestr, 0, 4);
		$month = substr($datestr, 4, 2);
		$day = substr($datestr, 6, 2);
		$hour = substr($datestr, 8, 2);
 		$mins = substr($datestr, 10, 2);
		$secs = substr($datestr, 12, 2);

		if ((int)$mins >= 30)
		{
			$mins = 30;
			$sqlmins = 45;
		}
		else
		{
			$mins = 0;
			$sqlmins = 15;
		}

		$am = 1;
		if ($hour >= 12)
		{
			$am = 0;
		}

		$this->unixtime = mktime($hour, $mins, 0, $month, $day, $year);
		$this->humantime = date("h:i A", $this->unixtime);
		$this->sqltime = date('YmdHis', mktime($hour, $sqlmins, 50, $month, $day, $year));
	}
}



//
//	Container for recording data
//

class Recording
{
	var $chanid;
	var $starttime;
}


//
//	All about channels
//
class Channel
{
	var $channum;
	var $chanid;
	var $callsign;
	var $icon;

	function repathIcon()
	{
		$this->icon = "images/icons/" . basename($this->icon);
	}	

}

//
//	Programs class
//
class ProgramInfo
{
	var $title;
	var $subtitle;
	var $chanstr;
	var $chanid;
	var $startts;
	var $endts;
	var $progType;
	var $description;
	var $duration;
	var $recordColour;
	var $typeColour;

	function setColours($a, $b)
	{
		$this->recordColour = $a;
		$this->typeColour = $b;
	}

	function printYourself($descFlag, $width, $anOffset)
	{

		print("<TD VALIGN=\"TOP\" WIDTH=\"17%\" COLSPAN=\"$width\" BGCOLOR=\"$this->typeColour\">");

		print("<TABLE VALIGN=\"TOP\" WIDTH=\"100%\"  HEIGHT=\"100%\" BGCOLOR=\"$this->recordColour\" CELLSPACING=\"0\" CELLPADDING=\"2\">");
		print("<TR VALIGN=\"TOP\"><TD VALIGN=\"TOP\" HEIGHT=\"100%\">");
		print("<TABLE VALIGN=\"TOP\" WIDTH=\"100%\" HEIGHT=\"100%\" BGCOLOR=\"$this->typeColour\" CELLSPACING=\"0\" CELLPADDING=\"2\">");
		print("<TR VALIGN=\"TOP\"><TD VALIGN=\"TOP\" HEIGHT=\"100%\">");


		print("<A HREF=\"main.php?mode=single&channel=$this->chanid&starttime=$this->startts&endtime=$this->endts&refoffset=$anOffset\">$this->title");
		if(strlen($this->subtitle) > 0)
		{
			print(": $this->subtitle");
		}
		print("</A>");
		if(strlen($this->progType) > 0)
		{
			print(" ($this->progType) ");
		}
		if($descFlag == "TRUE")
		{
			print(" $this->description");
		}


		print("</TD></TR>");
		print("</TABLE>");

		print("</TD></TR>");
		print("</TABLE>");

		print("</TD>");
/*
		print "\t<TD VALIGN=\"CENTER\" HEIGHT=\"100%\"colspan=\"$width\" BGCOLOR=\"$this->typeColour\"><TABLE WIDTH=\"100%\" HEIGHT=\"100%\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"2\" BGCOLOR=\"$this->recordColour\">\n\t\t<TR HEIGHT=\"100%\" WIDTH=\"100%\">\n\t\t\t<TD HEIGHT=\"100%\" WIDTH=\"100%\">\n";
		print "\t\t\t\t<TABLE WIDTH=\"100%\" HEIGHT=\"100%\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"2\" BGCOLOR=\"$this->typeColour\">\n\t\t\t\t\t<TR HEIGHT=\"100%\">\n\t\t\t\t\t\t<TD HEIGHT=\"100%\">\n";
		print("<A HREF=\"main.php?mode=single&channel=$this->channel&starttime=$this->startts\">$this->title");
		if(strlen($this->subtitle) > 0)
		{
			print(": $this->subtitle");
		}
		print("</A>");
		if(strlen($this->progType) > 0)
		{
			print(" ($this->progType) ");
		}
		if($descFlag == "TRUE")
		{
			print(" $this->description");
		}
		print "\n\t\t\t\t\t\t</TD>\n\t\t\t\t\t</TR>\n\t\t\t\t</TABLE>\n";
		print "\t\t\t</TD>\n\t\t</TR>\n\t</TABLE>\n</TD>";
*/
	}
}


?>
