<?php

	//
	//	This file is part of MythWeb,
	//	a php-based interface into MythTV.
	//
	//	(c) 2002 by Thor Sigvaldason and Isaac Richards
	//	MythWeb is distributed under the
	//	GNU GENERAL PUBLIC LICENSE version 2
	//	(see http://www.gnu.org)
	//

	
//
//	This file contains a few handy functions
//


//
//	Print a quote (up on the banner)
//

function printQuote($theQuote, $theAuthor, $fontface, $fontsize, $fontcolor)
{

	print("\t\t\t\t\t<TABLE>\n");
	print("\t\t\t\t\t\t<TR>\n");
	print("\t\t\t\t\t\t\t<TD>\n");
	print("\t\t\t\t\t\t\t\t<FONT FACE=\"$fontface\" SIZE=\"+1\" COLOR=\"$fontcolour\">\"<I>$theQuote\"</I></FONT>\n");
	print("\t\t\t\t\t\t\t</TD>\n");
	print("\t\t\t\t\t\t</TR>\n");
	print("\t\t\t\t\t\t<TR>\n");
	print("\t\t\t\t\t\t\t<TD ALIGN=\"RIGHT\">\n");
	print("\t\t\t\t\t\t\t\t<FONT FACE=\"$fontface\" SIZE=\"$fontsize\" COLOR=\"$fontcolour\">$theAuthor</FONT>\n");
	print("\t\t\t\t\t\t\t</TD>\n");
	print("\t\t\t\t\t\t</TR>\n");
	print("\t\t\t\t\t</TABLE>\n");
	
}

//
//	Print the date with any offset included
//

function printTheDate($time, $offset, $numbSlots)
{
	$adjuster = round(30 * $numbSlots * $offset);
	$theYear = substr($time, 0, 4);
	$theMonth = substr($time, 4, 2); 
	$theDay = substr($time, 6, 2);
	$theHour = substr($time, 8, 2);
	$theMinute = substr($time, 10, 2);
	
	$soTheDateMustBe = date("l (F j)", mktime($theHour, $theMinute + adjuster, 0, $theMonth, $theDay, $theYear)); 
	print("$soTheDateMustBe");
}

//
//	Given a program name, set the MySQL MythTV database
//	to record that program whenever it's shown
//

function recordAlways($programName)
{
	if(strlen($programName) > 0) // Are there program names as short as one character?
	{
		$alreadyThereQuery = mysql_query("select title from allrecord where title = \"$programName\"");
		if(mysql_num_rows($alreadyThereQuery) < 1)
		{
			//
			//	This program name is not in the allrecord table,
			//	so we need to add it
			//
			mysql_query("insert into allrecord (title) values (\"$programName\")");	
			
			//
			//	In case this is elsewhere, we should (?) delete it
			//	
			
			mysql_query("delete from singlerecord where title = \"$programName\"");
			mysql_query("delete from timeslotrecord where title = \"$programName\"");

			//
			//	Tell mythfrontend that something has changed
			//
			mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
		}
	}
}

//
//	Given a starting time and channel number, set the
//	database to record that program once
//

function recordOnce($channel, $start)
{
	//
	//	Because we only have the channel number and starting time,
	//	We need to look up the rest of the information
	//
	
	$aQuery = mysql_query("select chanid, starttime, endtime, title, subtitle, description from program where chanid = $channel and starttime = $start ");
	if($theRow = mysql_fetch_row($aQuery))
	{
		//
		//	It exists, so delete all references 
		//	and then create a singlerecord entry
		//
		dontRecord($theRow[3], $theRow[0], $theRow[1]);
		$anotherQuery = mysql_query("insert into singlerecord (chanid, starttime, endtime, title, subtitle, description) values ($theRow[0], \"$theRow[1]\", \"$theRow[2]\", \"$theRow[3]\", \"$theRow[4]\", \"$theRow[5]\")");
		//
		//	Tell mythfrontend that something has changed
		//
		mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
	}
	
}

//
//	Given a channel, a starting time, an ending time
//	and a title, record a program every day in that slot 
//

function recordTimeslot($channel, $start, $end, $title)
{
	//
	//	Delete all recording settings relevant to this
	//	program and then set timeslotrecord
	//
	dontRecord($title, $channel, $start);
	$aQuery = mysql_query("insert into timeslotrecord (chanid, starttime, endtime, title) values ($channel, \"$start\", \"$end\", \"$title\")");
	//
	//	Tell mythfrontend that something has changed
	//
	mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
}

//
//	Given a name, a channel number, and a starting time
//	make sure I neither "always record" this program
//	nor "record once" the program nor "timeslot record" it
//

function dontRecord($programName, $channel, $start)
{
	$aQuery = mysql_query("delete from allrecord where title = \"$programName\"");
	$bQuery = mysql_query("delete from singlerecord where chanid = $channel and starttime = \"$start\"");
	$cQuery = mysql_query("delete from timeslotrecord where chanid = $channel and starttime = \"$start\" and title = \"$programName\"");
	//
	//	Tell mythfrontend that something has changed
	//
	mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
}

//
//	Boolean check to see if a given title is in 
//	the allrecord table
//

function isInAlwaysRecord($theTitle)
{
	$aQuery = mysql_query("select * from allrecord where title = \"$theTitle\"");
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}

//
//	Boolean check to see if a given title is in 
//	the timeslotrecord table
//

function isInTimeslotRecord($theChannel, $theStart, $theEnd, $theTitle)
{
	$aQuery = mysql_query("select * from timeslotrecord where chanid = \"$theChannel\" and starttime = \"$theStart\" and endtime = \"$theEnd\" and title = \"$theTitle\"");
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}

//
//	Make a decent guess about whether this is a movie
//	or not
//
function smellsLikeMovie($length, $type)
{
	if($length > 70)
	{
		if(	$type == "Drama" ||
			$type == "Doc" ||
			$type == "Mystery" ||
			$type == "Musical" ||
			$type == "Action" ||
			$type == "Comedy" ||
			$type == "War" ||
			$type == "Romance" ||
			$type == "Crime" ||
			$type == "SciFi" ||
			$type == "Horror")
		{
			return(TRUE);
		}
	}
	return(FALSE);
}


//
//	Build an array of time slots based on the
//	starting time and the number of slots desired
//
function setupTimes ($starttime, $numbSlots)
{
	$currenttime = $starttime;

	for ($i = 0; $i < $numbSlots; $i += 1)
	{
		$mytime = new TimeValue;
 		$mytime->setVals($currenttime);
 		$timearray[$i]=$mytime;
		$currenttime = date('YmdHis', ($mytime->unixtime + 1800));
	}
 	return $timearray;
}


//
//	Build an array that contains info about
//	recordings.
//
function setupRecordings()
{
	$recordQuery = mysql_query("SELECT * FROM singlerecord") or die("Uh oh, I couldn't open the singlerecord table");;
	$i = 0;
	while($recordTupple = mysql_fetch_array($recordQuery, MYSQL_ASSOC))
	{
		$aRecord = new Recording;
		$aRecord->chanid = $recordTupple["chanid"];
		$aRecord->starttime = $recordTupple["starttime"];
		$recordArray[$i] = $aRecord;
		$i += 1;
	}
	return $recordArray;
}

//
//	Populate info about channels
//
function setupChannels ()
{
	$chanquery = "SELECT * FROM channel ORDER BY channum + 0";

	$chanresult = mysql_query($chanquery) or die("Eeek. I couldn't open the channel table in the mythconverg database.");
   
	$i = 0;

	while ($chanline = mysql_fetch_array($chanresult, MYSQL_ASSOC))
	{
	    $mychan = new Channel;
	    $mychan->chanid = $chanline["chanid"];
	    $mychan->channum = $chanline["channum"];
	    $mychan->callsign = $chanline["callsign"];
	    $mychan->icon = $chanline["icon"];   
	    $mychan->repathIcon();

	    $channelarray[$i] = $mychan;
	    $i += 1;
	}

	mysql_free_result($chanresult);
	return $channelarray;
}

//
//	So, anything good on TV?
//
function setupPrograms ($channelarray, $timearray, $numbSlots)
{
	$channelindex = 0;
	while ($mychannel = $channelarray[$channelindex])
	{
		for ($i = 0; $i < $numbSlots; $i += 1)
		{
			$mytime = $timearray[$i];
			$sqltime = $mytime->sqltime;

			$chanid = $mychannel->chanid;
			
			$query = "SELECT channel.chanid, starttime, endtime, title, subtitle, description, category, ((UNIX_TIMESTAMP(endtime) - UNIX_TIMESTAMP(starttime)) / 60 ) as duration, channel.channum FROM program,channel WHERE program.chanid = " . $chanid . " AND program.chanid = channel.chanid AND " .
			"starttime < " . $sqltime . " AND endtime > " . $sqltime .
			" ORDER BY channel.channum + 0, starttime;";

			$result = mysql_query($query) or die("Gadzooks! I can't open the program table.");

 			while ($line = mysql_fetch_array($result, MYSQL_ASSOC))
			{
				$myprog = new ProgramInfo;
				$myprog->title = $line["title"];
				$myprog->subtitle = $line["subtitle"];
				$myprog->chanid = $line["chanid"];
				$myprog->chanstr = $line["channum"];
				$myprog->startts = $line["starttime"];
				$myprog->endts = $line["endtime"];
				$myprog->progType = $line["category"];
				$myprog->duration = $line["duration"];
				$myprog->description = $line["description"];

				$programarray[$channelindex][$i] = $myprog;
			}

			mysql_free_result($result);
		}
  		$channelindex += 1;
	}
	return $programarray;
}


?>
