<?php


	//
	//	This file is part of MythWeb,
	//	a php-based interface into MythTV.
	//
	//	(c) 2002 by Thor Sigvaldason and Isaac Richards
	//	MythWeb is distributed under the
	//	GNU GENERAL PUBLIC LICENSE version 2
	//	(see http://www.gnu.org)
	//


//
//	listings.php is the default mode that
//	shows current listings.
//



//
//	See if we got passed a time offset on the URL (GET)
//	or (if not) use the current system time.
//
if(!isset($_GET["timeoffset"]))
{
	$sqlstarttime = date('YmdHis');
	$theOffset = 0;
}
else
{
	$theOffset = $_GET["timeoffset"];
	$adjuster = round(30 * $timeSlots * $_GET["timeoffset"]);
	$sqlstarttime = date("YmdHis", mktime(date(H), date(i) + $adjuster,date(s),date(m),date(d),date(Y)));
}


//
//	Build some data structures
//	(channels, programs, etc.)
//
$timearray = setupTimes($sqlstarttime, $timeSlots);
$channelarray = setupChannels();
$recordArray = setupRecordings();
$programarray = setupPrograms($channelarray, $timearray, $timeSlots);


//
//	Start outputing. First a big
//	table in the "background" colour just to
//	set the colour and show the lines 
//	between programs
//	
print("\n\n\t\t<TABLE WIDTH=\"100%\" BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" BGCOLOR=\"$list_fg_colour\">\n\t\t\t<TR>\n\t\t\t\t<TD>\n");

//
//	A second table where the actual <TR><TD>
//	data goes (with CELLSPACING "holes" to
//	see the background colour through)
//
print("\t\t\t\t\t<TABLE WIDTH=\"100%\" BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"5\" BGCOLOR=\"$list_fg_colour\">\n");

//
//	A full width cell that display the date
//
print("\t\t\t\t\t\t<TR>\n\t\t\t\t\t\t\t<TD>\n\t\t\t\t\t\t\t</TD>\n\t\t\t\t\t\t\t<TD ALIGN=\"CENTER\" COLSPAN=\"$timeSlots\" BGCOLOR=\"$list_bg_colour\">\n\t\t\t\t\t\t\t\t");
printTheDate($sqlstarttime, $theOffset, $timeSlots);
print("\n\t\t\t\t\t\t\t</TD>\n\t\t\t\t\t\t</TR>\n");

//
//	Left arrow to go back in time
//	(if only it were that easy)
//
print("\t\t\t\t\t\t<TR>\n");
$pastOffset = $theOffset - 1;
$futureOffset = $theOffset + 1;
print "\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t<A HREF=\"main.php?mode=listings&timeoffset=$pastOffset\"><IMG SRC=\"images/left.gif\" BORDER=\"0\" ALT=\"left\"></A>\n\t\t\t\t\t\t\t</td>\n";


//
//	The headings for the time columns
//
for ($timeslot = 0; $timeslot < $timeSlots; $timeslot += 1)
{
    $theTime = $timearray[$timeslot];
    $theTime->setColour($list_fg_colour, $list_bg_colour);
    $theTime->printYourself();
}

//
//	Right arrow to go forward in time
//
print "<TD><A HREF=\"main.php?mode=listings&timeoffset=$futureOffset\"><IMG SRC=\"images/right.gif\" BORDER=\"0\" ALT=\"right\"></A></TD>";
print "\t</tr>\n";


//
//	Sort down by channels and across by program
//
$channelindex = 0;
while ($mychannel = $channelarray[$channelindex])
{
	print "\t\t<TR><td>" . $mychannel->channum . "<br>" . 
	$mychannel->callsign . "</td>\n";
	//
	//	NOTE TO SELF Icon stuff (needs work)
	//
	//print("\t\t<TR HEIGHT=\"100%\"><TD>");
	//print("<IMG SRC=\"$mychannel->icon\" ALT=\"$mychannel->channum\">");
	//print("</TD>");

	$lasttitle = " ";
	$lastsubtitle = " ";
	for ($timeslot = 0; $timeslot < $timeSlots; $timeslot += 1)
	{
		$proginfo = $programarray[$channelindex][$timeslot];

                if ($proginfo == null)
                    continue;

		$finalColour = $list_bg_colour;
		if ($proginfo->title != $lasttitle || $proginfo->subtitle != $lastsubtitle)
		{
			$cellwidth = 1;
			for ($testnext = $timeslot + 1; $testnext < $timeSlots; $testnext += 1)
			{
				//
				//	Try and figure out how long something
				//	is in 30 minute segments
				//
				$testproginfo = $programarray[$channelindex][$testnext];
				
				if (	$testproginfo->title == $proginfo->title && $testproginfo->subtitle == $proginfo->subtitle)
				{
					$cellwidth += 1;
				}
				else
				{
					break;
				}
			}
			if(smellsLikeMovie($proginfo->duration, $proginfo->progType))
			{
				$finalColour = $movie_colour;
			}
			else
			{
				$finalColour = $colorArray[$proginfo->progType];
			}
			if ($finalColour == "")
			{
				$finalColour = $list_bg_colour;
			}
			$proginfo->setColours($finalColour, $finalColour);
			$recordArrayIndex = 0;
			//
			//	Check and see if this is in Record
			//	Once data
			//
			while($aRecord = $recordArray[$recordArrayIndex])
			{
				if($aRecord->chanid == $proginfo->chanid &&
					$aRecord->starttime == $proginfo->startts)
				{
					$proginfo->setColours($list_reccolour, $finalColour);
				}
					
				$recordArrayIndex += 1;	
			}
			//
			//	Check and see if this is an 
			//	always record or a timeslot
			//	record
			//
			if(isInAlwaysRecord($proginfo->title) || 
			isInTimeslotRecord($proginfo->channel, $proginfo->startts, $proginfo->endts, $proginfo->title))
			{
				$proginfo->setColours($list_reccolour, $finalColour);
			}
			//print "\t\t<td colspan=\"$cellwidth\" VALIGN=\"TOP\" BGCOLOR=\"$list_bg_colour\">";
			$proginfo->printYourself($includeDescription, $cellwidth, $theOffset);
			//print "</td>";
		}
		$lasttitle = $proginfo->title;
		$lastsubtitle = $proginfo->subtitle;
	}
	print "\t</tr>\n";
	$channelindex += 1;
}
print "</TABLE></TD></TR></TABLE>\n";


?>
